'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _echartsForReact = require('echarts-for-react');

var _echartsForReact2 = _interopRequireDefault(_echartsForReact);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var GitGraph = function (_Component) {
    _inherits(GitGraph, _Component);

    function GitGraph(props) {
        _classCallCheck(this, GitGraph);

        var _this = _possibleConstructorReturn(this, (GitGraph.__proto__ || Object.getPrototypeOf(GitGraph)).call(this, props));

        _this.state = {
            width: props.width || 960,
            height: props.height || 480,
            pullRequests: props.pullRequests
        };
        _this.getPullRequestsConvertedToEchartsFormat = _this.getPullRequestsConvertedToEchartsFormat.bind(_this);
        return _this;
    }

    _createClass(GitGraph, [{
        key: 'getPullRequestsConvertedToEchartsFormat',
        value: function getPullRequestsConvertedToEchartsFormat() {
            var nestedBranches = GitGraph.getNestedBranches(this.state.pullRequests);
            var convertedBranches = [];
            Object.getOwnPropertyNames(nestedBranches).forEach(function (key) {
                convertedBranches.push(GitGraph.convertNestedBranchToEchartsFormat(nestedBranches[key], key));
            });
            return convertedBranches;
        }
    }, {
        key: 'render',
        value: function render() {
            var data = this.getPullRequestsConvertedToEchartsFormat();

            var numberOfDatum = Object.keys(data).length;

            return _react2.default.createElement(
                'div',
                null,
                data.map(function (datum, index) {
                    var option = {
                        tooltip: {
                            trigger: 'item',
                            triggerOn: 'mousemove'
                        },
                        series: [{
                            type: 'tree',

                            data: [datum],

                            top: '1%',
                            left: '1%',
                            bottom: '1%',
                            right: '20%',

                            symbolSize: 7,

                            label: {
                                normal: {
                                    position: 'right',
                                    verticalAlign: 'top',
                                    align: 'left',
                                    fontSize: 9
                                }
                            },

                            leaves: {
                                label: {
                                    normal: {
                                        position: 'right',
                                        verticalAlign: 'middle',
                                        align: 'left'
                                    }
                                }
                            },

                            expandAndCollapse: true,
                            animationDuration: 550,
                            animationDurationUpdate: 750
                        }]
                    };
                    return _react2.default.createElement(_echartsForReact2.default, {
                        key: index,
                        style: { height: this.state.height / numberOfDatum, width: '100%' },
                        option: option });
                }.bind(this))
            );
        }
    }], [{
        key: 'convertNestedBranchToEchartsFormat',
        value: function convertNestedBranchToEchartsFormat(nestedBranch, name) {
            var echartsFormat = {
                name: name,
                children: []
            };
            Object.getOwnPropertyNames(nestedBranch).forEach(function (key) {
                echartsFormat.children.push(GitGraph.convertNestedBranchToEchartsFormat(nestedBranch[key], key));
            });
            return echartsFormat;
        }
    }, {
        key: 'getNestedBranches',
        value: function getNestedBranches(pullRequests) {
            var sourceBranches = pullRequests.map(function (pullRequest) {
                return pullRequest.source;
            });
            var targetBranches = pullRequests.map(function (pullRequest) {
                return pullRequest.target;
            });

            var nestedBranches = {};
            targetBranches.forEach(function (target) {
                if (sourceBranches.indexOf(target) === -1 && !nestedBranches.hasOwnProperty(target)) {
                    nestedBranches[target] = GitGraph.getChildBranches(pullRequests, target);
                }
            });

            return nestedBranches;
        }
    }, {
        key: 'getChildBranches',
        value: function getChildBranches(pullRequests, source) {
            var children = {};
            pullRequests.forEach(function (possibleChild) {
                if (possibleChild.target === source) {
                    children[possibleChild.source] = GitGraph.getChildBranches(pullRequests, possibleChild.source);
                }
            });

            return children;
        }
    }, {
        key: 'getDerivedStateFromProps',
        value: function getDerivedStateFromProps(props, state) {
            return {
                pullRequests: props.pullRequests
            };
        }
    }]);

    return GitGraph;
}(_react.Component);

exports.default = GitGraph;